]> diplodocus.org Git - nmh/blob - test/common.sh.in
Change the MD5FMT macro in configure.ac to not emit filename.
[nmh] / test / common.sh.in
1 # Common helper routines for test shell scripts -- intended to be sourced by them
2 # @configure_input@
3
4
5 #### The following exported variables are set by "make check". Ensure
6 #### that they are set here so that individual tests can be run
7 #### outside of make. Requires that MH_OBJ_DIR be set on entry.
8 test -z "$MH_TEST_DIR" && MH_TEST_DIR="$MH_OBJ_DIR/test/testdir"
9 test -z "$prefix" && prefix=@prefix@
10 test -z "$datarootdir" && datarootdir=@datarootdir@
11 test -z "$exec_prefix" && exec_prefix=@exec_prefix@
12 test -z "$auxexecdir" && auxexecdir="@libdir@"
13 test -z "$bindir" && bindir="@bindir@"
14 test -z "$mandir" && mandir="@mandir@"
15 test -z "$sysconfdir" && sysconfdir="@sysconfdir@"
16 test -z "$MULTIBYTE_ENABLED" && MULTIBYTE_ENABLED="@MULTIBYTE_ENABLED@"
17 export MH_TEST_DIR auxexecdir bindir mandir sysconfdir
18 export MULTIBYTE_ENABLED
19
20 test -z "$MH_INST_DIR" && MH_INST_DIR="${MH_TEST_DIR}/inst"
21 export MH_INST_DIR
22
23 unset MHBUILD MHCONTEXT MHMTSUSERCONF MHN MHSHOW MHSTORE MHTMPDIR
24 unset MHLDEBUG MHPDEBUG MHWDEBUG MM_CHARSET PAGER
25
26 output_md5()
27 {
28 #### Output just the checksum. If the filename needs to appear on
29 #### the same line, the caller needs to add it. This avoids
30 #### differences due to a leading '*' binary file indicator, for
31 #### text files, on some platforms (Cygwin).
32 @MD5SUM@ $* | @MD5FMT@ | cut -d ' ' -f 1
33 }
34
35 #### Use built-in $((...)) in test suite if shell supports it.
36 #### Borrowed from configure's as_fn_arith. The result is placed
37 #### in global arith_val.
38 #### Detected at run-time instead of by configure to allow testing
39 #### with different shells.
40 if (eval "test \$(( 1 + 1 )) = 2" 2>/dev/null); then
41 eval 'arith_eval () { arith_val=$(( $* )); }'
42 else
43 arith_eval () { arith_val=`expr "$@" || test $? -eq 1`; }
44 fi
45
46 test_skip ()
47 {
48 WHY="$1"
49 echo "$Test $0 SKIP ($WHY)"
50 exit 77
51 }
52
53 # portable implementation of 'which' utility
54 findprog()
55 {
56 PROG="$1"
57 #### Don't need to save current IFS because this function is run in
58 #### a subshell.
59 IFS=:
60 for D in $PATH; do
61 if [ -z "$D" ]; then
62 D=.
63 fi
64 if [ -f "$D/$PROG" -a -x "$D/$PROG" ]; then
65 printf '%s\n' "$D/$PROG"
66 break
67 fi
68 done
69 }
70
71 require_prog ()
72 {
73 if [ -z "`findprog $1`" ]; then
74 test_skip "missing $1"
75 fi
76 }
77
78 # Some stuff for doing silly progress indicators
79 if [ -t 1 ] ; then
80 progress_update ()
81 {
82 THIS="$1"
83 FIRST="$2"
84 LAST="$3"
85 arith_eval $LAST - $FIRST; RANGE=$arith_val
86 arith_eval $THIS - $FIRST; PROG=$arith_val
87 # this automatically rounds to nearest integer
88 arith_eval 100 \* $PROG / $RANGE; PERC=$arith_val
89 # note \r so next update will overwrite
90 printf '%3d%%\r' $PERC
91 }
92
93 progress_done ()
94 {
95 printf '100%%\n'
96 }
97 else
98 # don't emit anything if stdout is not connected to a tty.
99 progress_update ()
100 {
101 :
102 }
103 progress_done ()
104 {
105 :
106 }
107 fi
108
109 check_for_hard_links () {
110 set +e
111
112 printf '' > "${MH_TEST_DIR}/$$-1"
113 if link "${MH_TEST_DIR}/$$-1" "${MH_TEST_DIR}/$$-2" 2>/dev/null; then
114 hard_links_supported=1
115 else
116 hard_links_supported=0
117 fi
118 rm -f "${MH_TEST_DIR}/$$-1" "${MH_TEST_DIR}/$$-2"
119
120 set -e
121 }
122
123 #### check() requires two arguments, each the name of a file to be
124 #### diff'ed.
125 #### If the same, the second file is removed. And the first file is
126 #### removed unless the optional third argument has a value of
127 #### 'keep first'.
128 #### If different, global variable "failed" is incremented.
129 check() {
130 #### POSIX diff should support -c.
131 if diff -c "$1" "$2"; then
132 test $# -lt 3 -o "$3" != 'keep first' && rm -f "$1"
133 rm -f "$2"
134 else
135 echo "$0: test failed, outputs are in $1 and $2."
136 failed=`expr ${failed:-0} + 1`
137 fi
138 }
139
140 #### run_test() requires two arguments, the first is a program and
141 #### arguments, the second is its expected one-line output string.
142 #### If the actual output does not match that string:
143 #### an error message is printed and global variable "failed" is incremented;
144 #### if there is an optional third argument, it is used in the error message.
145 run_test() {
146 set +e
147 actual_output=`$1 2>&1`
148 set -e
149 if test x"$actual_output" != x"$2"; then
150 echo "$0: ${3:-\"$1\"} expected:" 1>&2
151 echo " '$2'" 1>&2
152 echo "but instead got:" 1>&2
153 echo " '$actual_output'" 1>&2
154 failed=`expr ${failed:-0} + 1`
155 fi
156 }
157
158 setup_test ()
159 {
160 MH="${MH_TEST_DIR}/Mail/.mh_profile"
161 MHMTSCONF="${MH_INST_DIR}${sysconfdir}/mts.conf"
162 PATH="${MH_INST_DIR}${bindir}:${PATH}"
163 MH_LIB_DIR="${MH_INST_DIR}${auxexecdir}"
164 export MH MHMTSCONF MH_LIB_DIR PATH
165
166 #
167 # Only install once
168 #
169 if [ -d "${MH_INST_DIR}${bindir}" ]; then
170 :
171 else
172 (cd "${MH_OBJ_DIR}" &&
173 make DESTDIR="${MH_INST_DIR}" SETGID_MAIL= install) ||
174 exit 1
175
176 #### Don't test with sendmail because it would really send the
177 #### mail. If configured to use sendmail, change to smtp instead
178 #### so that we use fakesmtp.
179 #### And set up the maildrop in the test directory so tests don't
180 #### use the user's real maildrop.
181 #### test-slocal needs to look at the original mts.conf, so save it.
182 mv -f "${MHMTSCONF}" "${MHMTSCONF}.old"
183 sed -e 's/mts: *.*/mts: smtp/' \
184 -e "s%mmdfldir: *.*%mmdfldir: ${MH_TEST_DIR}/Mail%" \
185 -e 's%mmdflfil: *.*%mmdflfil: maildrop%' \
186 "${MHMTSCONF}.old" >"${MHMTSCONF}"
187 fi
188
189 # clean old test data
190 trap "rm -rf '$MH_TEST_DIR/Mail'" 0
191 # setup test data
192 mkdir "$MH_TEST_DIR/Mail" || exit 1
193 cat > "$MH" <<EOF || exit 1
194 Path: ${MH_TEST_DIR}/Mail
195 buildmimeproc: ${MH_INST_DIR}${bindir}/mhbuild
196 fileproc: ${MH_INST_DIR}${bindir}/refile
197 libdir: ${MH_LIB_DIR}
198 mhbuild: -nocontentid
199 mhlproc: ${MH_LIB_DIR}/mhl
200 moreproc: cat
201 postproc: ${MH_LIB_DIR}/post
202 showproc: ${MH_LIB_DIR}/mhl
203 EOF
204
205 for f in MailAliases components digestcomps distcomps forwcomps mhl.body \
206 mhl.digest mhl.format mhl.forward mhl.headers mhl.reply \
207 mhn.defaults rcvdistcomps replcomps replgroupcomps scan.MMDDYY \
208 scan.YYYYMMDD scan.default scan.highlighted scan.mailx scan.nomime \
209 scan.size scan.time scan.timely scan.unseen
210 do
211 cp "${MH_INST_DIR}${sysconfdir}/${f}" "${MH_TEST_DIR}/Mail" || exit 1
212 done
213
214 folder -create +inbox > /dev/null
215 # create 10 basic messages
216 for i in 1 2 3 4 5 6 7 8 9 10;
217 do
218 cat > $MH_TEST_DIR/Mail/inbox/$i <<EOF || exit 1
219 From: Test$i <test$i@example.com>
220 To: Some User <user@example.com>
221 Date: Fri, 29 Sep 2006 00:00:00
222 Message-Id: $i@test.nmh
223 Subject: Testing message $i
224
225 This is message number $i
226 EOF
227 done
228 }